;ͻ
; Programm  Versuch3.asm                                                  
;                                                                         
; Compiler  Turbo Assembler 3.0, TASMX-Oberflaeche 1.54                   
;                                                                         
; Datum     Karlsruhe, den 04.07.94                                       
;                                                                         
; Gruppe    Jan Horbach, Thomas Unkelbach                                                              
;                                                                         
; Autor     Hartung Wilstermann & Ingo Gabriel                            
;Ķ
; Inhalt    Lauflicht, Ein/Ausgabe mit 8255                               
;ͼ

;ͻ
; Programmkopf                                                             
;ͼ
	TITLE 'Mikrorechnerpraktikum 1'
	P486                    ;Prozessortyp angeben, 486 Code zulassen
	DOSSEG                  ;Segmente DOS-konform anordnen
	.MODEL USE16 SMALL      ;Speichermodell auswaehlen
	STACK   100h            ;Stackgroee definieren

;ͻ
; Konstanendeklaration                                                     
;ͼ
	MSDOS           equ 21h ;MS-DOS Interruptnummer
	EXIT            equ 4Ch ;Programmende

;Ŀ
;  Konstanten fuer den I/O-Baustein 8255                                  
;
	PortA           equ 300h;Adresse Port A
	PortB           equ 301h;Adresse Port B
	CntlReg         equ 303h;Adresse Kontrollregister
	LslReset        equ 9Bh

;ͻ
; Variablendeklaration mit Anfangswert                                     
;ͼ
		DATASEG

;ͻ
; Variablendeklaration ohne Anfangswert                                    
;ͼ
		UDATASEG

;ͻ
; Programmdeklaration                                                      
;ͼ
		CODESEG

;͸
; Unterprogramme                                                           
;;
;Ŀ
; I/O-Baustein 8255 initialisieren                                         
;
InitPorts proc           ;8255-Baustein initialisieren
	push    ax      ;alle im Unterprogramm benutzte Register sichern
	push    dx
	mov     dx,CntlReg
	mov     ax,82h
	out     dx,ax
	pop     dx      ;Register restaurieren
	pop     ax
	ret             ;Ruecksprung
InitPorts endp          ;Unterprogramm Ende


;Ŀ
; Port A,B und C zuruecksetzen (alle auf Eingang)                          
;
ResetPorts proc         ;8255-Baustein zuruecksetzen
	push    ax      ;alle im Unterprogramm benutzte Register sichern
	push    dx
	mov     dx,CntlReg
	mov     ax,LslReset
	out     dx,ax     
	pop     dx      ;Register restaurieren
	pop     ax
	ret             ;Ruecksprung
ResetPorts endp         ;Unterprogramm Ende


;Ŀ
; Port B einlesen                                                          
;
ReadPortB proc          ;Liest Port B und uebergibt ihn ueber Stack an main
	push    ax      ;alle im Unterprogramm benutzte Register sichern
	push    dx
	push    bp
	mov     bp,sp
	mov     dx,PortB
	in      al,dx
	mov     [bp + 8],al
	pop     bp
	pop     dx      ;Register restaurieren
	pop     ax
	ret             ;Ruecksprung
ReadPortB endp          ;Unterprogramm Ende     


;Ŀ
; Port A ausgeben                                                          
;
WritePortA proc         ;Uebergebene Parameter auf Port A ausgeben
	push    ax      ;alle im Unterprogramm benutzte Register sichern
	push    dx
	push    bp
	mov     bp,sp
	mov     dx,PortA
	mov     al,[bp + 8]
	out     dx,al
	pop     bp
	pop     dx      ;Register restaurieren
	pop     ax
	ret 2           ;Ruecksprung
WritePortA endp         ;Unterprogramm Ende

;Dezimal-Zhler, alle 10 Verschiebungen +1

ZaehlerAusgabe proc
	push ax
	push dx
	push bx
	push cx
	push bp
	mov bp,sp
	mov cx,0
	mov ax,[bp+12]
	mov bx,10

sprg5:	mov dx,0
	div bx
	push dx
	inc cx
	cmp ax,0
	jne sprg5
	mov ah,2h

sprg6:	pop dx
	add dl,'0'
	int MSDOS
	loop sprg6
	mov dl,13
	int MSDOS
	pop bp
	pop cx
	pop bx
	pop dx 
	pop ax		
	ret 2
ZaehlerAusgabe endp

;͸
; Hauptprogramm                                                            
;;
Main:   mov     ax,@DATA        ;Datensegment laden
	mov     ds,ax
	call    InitPorts
	mov	ax,0
	mov     bx,0
	mov     di,0
	mov     si,0
	mov 	cx,0
	mov 	dx,0
	
Sprg1:  push    di
	call    ReadPortB
	pop     di
	cmp     di,si
	je      Sprg2
	mov     si,di
	mov     bx,di
	jmp     Sprg3

Sprg2:  ror bl,1

Sprg3:  push bx
	call WritePortA
	mov ecx,9FFFFh 
	inc ax
	cmp ax,10
	jne sprg4
	inc dx
	push dx
	call ZaehlerAusgabe
	mov ax,0

Sprg4:  loopd Sprg4
	cmp  si,255
	jne Sprg1
	
	call    ResetPorts      ;Zuruecksetzen des 8255
	xor     ax,ax           ;Programm beenden
	mov     ah,Exit
	int     msdos
end     Main

