;ͻ
; Programm  Versuch4.asm                                                  
;                                                                         
; Compiler  Turbo Assembler 3.0, TASMX-Oberflaeche 1.54                   
;                                                                         
; Datum     Karlsruhe, den 04.07.94                                       
;                                                                         
; Gruppe    Thomas Unkelbach, Jan Horbach                                                              
;                                                                         
; Autor     Hartung Wilstermann & Ingo Gabriel                            
;Ķ
; Inhalt    Serielle Datenuebertragung mit dem 8250A                      
;ͼ

;ͻ
; Programmkopf                                                             
;ͼ
	TITLE 'Mikrorechnerpraktikum 1'
	P486                    ;Prozessortyp angeben, 486 Code zulassen
	DOSSEG                  ;Segmente DOS-konform anordnen
	.MODEL USE16 SMALL      ;Speichermodell auswaehlen
	STACK   100h            ;Stackgroee definieren

;ͻ
; Konstanendeklaration                                                     
;ͼ
	MSDOS           equ 21h ;MS-DOS Interruptnummer
	EXIT            equ 4Ch ;Programmende

;Ŀ
; Register (Umbennenung erlaubt und erwuenscht!!!)                        
;
	SHReg           equ 03E8h       ;Sendehalteregister
	LStatReg        equ 03EDh       ;Leitungsstatusregister
	LSteuReg        equ 03EBh       ;Leitungssteuerregister
	IFReg           equ 03E9h       ;Interruptfreigaberegister

;Ŀ
; Druckersteuerzeichen (Beispiele => Werte anpassen!!!)                   
;
	PrinterReset    equ 1Bh, 40h    ;ESC @ = Drucker initialisieren
	FettEin         equ 1Bh, 45h    ;ESC E = Fettdruck aktivieren
	FettAus         equ 1Bh, 46h    ;ESC F = Fettdruck deaktivieren


;ͻ
; Variablendeklaration mit Anfangswert                                     
;ͼ
		DATASEG
		   text db PrinterReset
		      	db "   +++++++++++   ", 13, 10
			db "  +++++++++++++  ", 13, 10
			db " +############+# ", 13, 10
			db "++###########++##", 13, 10
			db "++##         ++##", 13, 10
			db "++##         ++##", 13, 10
			db "++##         ++##", 13, 10
			db "++##         ++##", 13, 10
			db "++##+++++++++++##", 13, 10
			db " +#++++++++++++# ", 13, 10
			db "  #############  ", 13, 10
			db "   ###########   ", 13, 10
			db 27,107,0, 27, 87,1
			db "Dies ist ein beliebiger Text in verschiedenen Druckarten",13,10
			db 27,87,0,FettEin, 27, 120,0
			db "Dies ist ein fetter Text",13,10
			db FettAus, 27,15
			db "So, jetzt ist Schluss"
			db 18, 0FFh                                                     
;ͻ
; Variablendeklaration ohne Anfangswert                                    
;ͼ
		UDATASEG

;ͻ
; Programmdeklaration                                                      
;ͼ
		CODESEG

;͸
; Unterprogramme                                                           
;;
;Ŀ
; Baustein 8250A initialisieren                                            
;
InitCom proc            ;8250A-Baustein initialisieren
	push    ax
	push    dx
	mov     ax,10000011b
	mov     dx,LSteuReg
	out     dx,al
	mov     dx,SHReg
	mov     ax,0Ch
	out     dx,ax
	mov     ax,3h
	mov     dx,LSteuReg
	out     dx,ax
	pop     dx
	pop     ax
	ret             ;Ruecksprung
InitCom endp            ;Unterprogramm Ende


;Ŀ
; Zeichen senden                                                           
;
SendChar proc           ;ein Zeichen senden
	push    bp
	mov     bp,sp
	push    ax
	push    dx
	
waits:  mov 	ax,0
	mov     dx,LStatReg
	in      al,dx
	and     al,01100000b
	cmp 	al,60h
	jne     waits
	mov     ax,[bp + 4]
	mov     dx,SHReg
	out     dx,ax
	pop     dx
	pop     ax
	pop     bp
	ret     2       ;Ruecksprung
SendChar endp           ;Unterprogramm Ende


;͸
; Hauptprogramm                                                            
;;
Main:   mov     ax,@DATA        ;Datensegment laden
	mov     ds,ax
	call    InitCom         ;Zuruecksetzen des 8250A
	mov     bx, offset Text
	mov     di,0

sprmk1: mov     di,[bx]
	cmp     di,0FFh     
	je      ende
	push    di
	call    SendChar
	inc     bx
	jmp     sprmk1

ende:   xor     ax,ax           ;Programm beenden
	mov     ah,Exit
	int     msdos
end     Main

