;ͻ
; Programm  Versuch6.asm                                                  
;                                                                         
; Compiler  Turbo Assembler 3.0, TASMX-Oberflaeche 1.54                   
;                                                                         
; Datum     Karlsruhe, den 04.07.94                                       
;                                                                         
; Gruppe    Thomas Unkelbach Jan Horbach	                                                              
;                                                                         
; Autor     Hartung Wilstermann & Ingo Gabriel                            
;Ķ
; Inhalt    Musikversuch                                                  
;ͼ

;ͻ
; Programmkopf                                                             
;ͼ
	TITLE 'Mikrorechnerpraktikum 1'
	P486                    ;Prozessortyp angeben, 486 Code zulassen
	DOSSEG                  ;Segmente DOS-konform anordnen
	.MODEL USE16 SMALL      ;Speichermodell auswaehlen
	STACK   100h            ;Stackgroee definieren

;ͻ
; Konstanendeklaration                                                     
;ͼ
	MSDOS           equ 21h ;MS-DOS Interruptnummer
	EXIT            equ 4Ch ;Programmende

;Ŀ
;  Konstanten fuer Toene                                                  
;


;Ŀ
;  Konstanten fuer den Interruptcontroller 8259A                          
;
	Master  equ 20h         ;Adresse des Kontrollregisters des 1. Inter-
				;ruptcontrollers
	Slave   equ 0A0h        ;Adresse des Kontrollregisters des 2. Inter-
				;ruptcontrollers
	IRQMask_1  equ  21h     ;Adresse der Maske des 1. IR-Controllers
	IRQMask_2  equ 0A1h     ;Adresse der Maske des 2. IR-Controllers
	GetIntVec  equ 35h      ;Funktionscode Get Interrupt Vector
	SetIntVec  equ 25h      ;Funktionscode Set Interrupt Vector
	IRQ10   equ 72h         ;Vektor 72h fuer IRQ10
	EOI     equ 20h         ;End of Interrupt (=20h)
	GLength equ 2000000

;Ŀ
;  Konstanten fuer den Timerbaustein 8253                                 
;
	Timer0  equ 0304h       ;Adresse Datenregister Zaehler 0
	Timer1  equ 0305h       ;Adresse Datenregister Zaehler 1
	Timer2  equ 0306h       ;Adresse Datenregister Zaehler 2
	TimerContr equ 0307h    ;Adresse Controlregister

;ͻ
; Variablendeklaration mit Anfangswert                                     
;ͼ
		DATASEG
	TonTable        dw 113,18182, 119,17161,  87,16198, 101,15289
			dw  69,14431, 114,13621,  82,12857, 116,12135
			dw 122,11454,  90,10811, 117,10205,  85, 9632
			dw 105, 9091, 111, 8581,  79, 8099, 112, 7645 
			dw  80, 7216,  97, 6811,  65, 6429, 115, 6068
			dw 100, 5727,  68, 5406, 102, 5103,  70, 4816
			dw 103, 4546, 104, 4291,  72, 4050, 106, 3823
			dw  74, 3608, 107, 3406,  75, 3215, 108, 3034
			dw 121, 2864,  89, 2703, 120, 2552,  88, 2408
			dw  57,    1, 0FFFFh
	
	TonLength       db 49,1, 50,2, 51,4, 52,8, 53,16, 54,32,0FFh

;ͻ
; Variablendeklaration ohne Anfangswert                                    
;ͼ
		UDATASEG
	Vec_Seg         dw ?    ;zur Sicherung von Routine-Segment bei IRQ
	Vec_Ofs         dw ?    ;zur Sicherung von Routine-Offset bei IRQ
	IRQStatus       db ?    ;Status der Interruptroutine (0= aus, 1= ein)
	TonFolge        db 20 dup (?)
	playmode        db ?

;ͻ
; Programmdeklaration                                                      
;ͼ
		CODESEG

;͸
; Unterprogramme                                                           
;;

;Ŀ
;  Einfuegen der Interruptroutine in die Vektortabelle                    
;
InitInter proc  
	push    ax              ;Register sichern
	push    dx

	mov     ah,GetIntVec    ;Funktionscode Get Interrupt Vector
	mov     al,IRQ10        ;IRQ10 wird verwendet, d.h. Vektor 72h
	int     MSDOS           ;int 21h
	mov     [Vec_Seg],es    ;Segment der Routine abspeichern
	mov     [Vec_Ofs],bx    ;Offset der Routine abspeichern

	mov     ah,SetIntVec    ;Funktionscode Set Interrupt Vector
	mov     al,IRQ10        ;Vektornummer laden
	push    ds              ;ds wird noch gebraucht => Register sichern     
	push    cs              ;die neue Interruptroutine steht im gleichen Segment
	pop     ds              ;daher wird der Inhalt von CS nach DS uebertragen
	mov     dx,offset Inter1;Offset der Routine nach DX
	int     MSDOS           ;int 21h

	pop     ds              ;Register restaurieren
	pop     dx
	pop     ax
	ret
InitInter endp

;Ŀ
;  Interrupts auf IRQ10 freigeben                                         
;
IRQ_On proc     
	push    ax              ;Register sichern
	in      al,IRQMask_2    ;Mask-Register des 2. Controllers
	and     al,0FBh         ;Bit 2 loeschen, gibt IRQ 10 frei
	out     IRQMask_2,al    ;Byte zurueckschreiben
	STI                     ;maskierbare Interrupts freigeben
	pop     ax              ;Register restaurieren
	ret
IRQ_On endp     

;Ŀ
;  IRQ10 ausschalten                                                      
;
IRQ_Off proc
	push    ax              ;Register sichern
	in      al,IRQMask_2    ;Mask-Register 2. Controller
	or      al,04h          ;Bit 2 setzen, sperrt Interrupts auf IRQ10
	out     IRQMask_2,al    ;Byte zurueckschreiben  
	pop     ax
	ret
IRQ_Off endp

;Ŀ
;  alte Interruptroutine wieder eintragen                                 
;
ResetInter proc
	push    ax              ;Register sichern
	push    dx
	push    ds                      
	mov     ds,[Vec_Seg]    ;Segment der Routine nach DS
	mov     dx,[Vec_Ofs]    ;Offset der Routine nach DX
	mov     ah,SetIntVec    ;Funktion Set Interrupt Vector
	mov     al,IRQ10        ;Vektornummer laden
	int     MSDOS           ;int 21h
	pop     ds              ;Datensegment restaurieren
	pop     dx              ;Register sichern
	pop     ax
	ret
ResetInter endp


;Ŀ
;  Timer vorbereiten                                                      
;
StartTimer proc
	push    bp
	mov     bp,sp
	push    dx
	push    ax
	mov     dx,TimerContr
	mov     al,00110110b
	out     dx,al
	mov     al,01110100b
	out     dx,al
	mov     al,10110000b
	out     dx,al
	mov     ax,[bp + 4]
	mov     dx,Timer0
	out     dx,al
	mov     al,ah
	out     dx,al
	mov     ax,[bp+6]
	mov     dx,Timer1
	out     dx,al
	mov     al,ah
	out     dx,al
	mov     ax,[bp+8]
	mov     dx,Timer2
	out     dx,al
	mov     al,ah
	out     dx,al
	pop     dx
	pop     ax
	pop     bp
	ret     6
StartTimer endp

StopTimer proc
	push    dx
	push    ax
	mov     al,00010000b
	mov     dx,TimerContr
	out     dx,al
	mov     al,01010000b
	out     dx,al
	mov     al,10010000b
	out     dx,al
	pop     ax
	pop     dx
	ret
StopTimer endp

;Ŀ
;  Interruptroutine reagiert auf Timer 2-Ausgang                          
;
Inter1  proc                    ;Interruptroutine          
	push    ax              ;Register sichern
	push    ds      
		
	mov     ax,@DATA        ;Datensegment laden
	mov     ds,ax           ;Ab jetzt kann auf Variablen zugegriffen werden
	
	mov     [IRQStatus],1h  ;Interruptroutine aufgerufen

	mov     al,EOI          ;End-Of-Interrupt-Code laden
	out     Master,al       ;Controllregister Controller 1
	out     Slave,al        ;Controllregister Controller 2
	pop     ds              ;Register restaurieren
	pop     ax              ;Register restaurieren
	iret                    ;Ende der Interruptroutine
Inter1  endp


;͸
; Hauptprogramm                                                            
;;
Main:   mov     ax,@DATA        ;Datensegment laden
	mov     ds,ax
	call    InitInter       ;Interruptroutine in Vektortabelle eintragen 
	call    IRQ_On          ;Interrupt einschalten (freigeben)
	mov     ecx,Glength

Schl1:  mov     [IRQStatus],0   ;InterruptStatusflag zuruecksetzen
	mov     [playmode],0
	mov     dx,0            ;dx zurcksetzen
	mov     di,0            ;di zurcksetzen
	mov	si,0
	mov     ax,0            ;ax zurcksetzen
	mov     ah,8h
	int     21h             ;Zeichen von der Tastatur einlesen

Schl2:  mov	ah,0
	cmp     al,48                   ;Zeichen = '0'
	je      Tona                    ;Tonaufnahme
	cmp     al,109                  ;Zeichen = 'm'
	je      Tonp                    ;Tonabspielen
	cmp     [TonTable + di],0FFFFh  ;Tabelle am Ende?
	je      Tonl                    ;Tonlaenge berprfen
	cmp     [TonTable + di],ax      ;vergleichen mit aktuellem Zeiche der Tabelle
	je      raus                    ;Strike!!!
	add     di,4                    ;Auf nchstes Zeichen der Tabelle setzen
	jmp     Schl2             

raus:   mov     ax,[TonTable + di + 2]  
	push    ecx                     ;Tonlnge pushen        
	push    ax                      ;Ton pushen
	call    StartTimer              ;Spiel procedure aufrufen

Schl3:  cmp     [IRQStatus],1h          ;Warten das Zeit umgeht
	jne     Schl3
	mov	[irqstatus],0
	call    StopTimer               ;Lautsprecher ruhigstellen
	cmp     [playmode],0            ;befindet sich das Programm im Playmode
	jne     Tonp

	jmp     Schl1

Tonl:   mov     di,0                    ;bx zurcksetzen
schl4:	cmp     [TonLength + di],0FFh  ;Ende der Tabelle errreicht
	je      Ende                    ;Ende!!!
	cmp     [TonLength + di],al     ;Vergleichen mit aktuellem Zeichen der Tabelle
	je      Tonl2                   ;Juhuuu
	add     di,2                    ;Auf nchstes Zeichen der Tabelle setzen
	jmp     schl4                     

Tonl2:  mov     bx,0
	mov 	cx,0
	mov     cl,TonLength+di +1
	;mov     si,bx
	;mov     cl,[si]                 ;Teiler einlesen
	mov     eax,GLength             ;Grundlnge einlesen
	div     cx                      ;Lnge bestimmen
	mov     ecx,eax
	cmp     [playmode],0            ;befindet sich das Programm im Playmode
	jne     Tonp
	jmp     Schl1

Tona:   mov	di,0
schl5:	mov     ah,8h
	int     21h                     ;Tastatur einlesen
	cmp     al,109                  ;'m' gedrckt?
	je      Schl1                   ;zurck zum Hauptprogramm
	mov	si, offset Tonfolge
	mov     [Tonfolge+di],al                 ;Speichern
	inc     di                      ;Zeiger verschieben
	jmp     schl5

Tonp:   mov     dx,0
	mov     [playmode],1h
	mov     al,[Tonfolge+si] 
	inc     si                      ;Zeiger verschieben
	jmp     Schl2

Ende:   call    IRQ_Off         ;Interrupt ausschalten 
	call    ResetInter      ;alte Interruptroutine wieder eintragen
	xor     ax,ax           ;Programm beenden
	mov     ah,Exit
	int     msdos
end     Main

