;ͻ
; Programm  Lauflich.asm                                                  
;                                                                         
; Compiler  Turbo Assembler 3.0, TASMX-Oberflaeche 1.54                   
;                                                                         
; Datum     Karlsruhe, den 04.05.98                                       
;                                                                         
; Gruppe                                                                  
;                                                                         
; Autor                              
;Ķ
; Inhalt    Lauflicht, Ein/Ausgabe mit 8255                               
;ͼ

;ͻ
; Programmkopf                                                             
;ͼ
	TITLE 'Mikrorechnerpraktikum 1'
	P486                    ;Prozessortyp angeben, 486 Code zulassen
	.MODEL USE16 SMALL             ;Speichermodell auswaehlen

;ͻ
; Konstanendeklaration                                                     
;ͼ
	MSDOS           equ 21h ;MS-DOS Interruptnummer

;Ŀ
;  Konstanten fuer den I/O-Baustein 8255                                  
;
	PortA           equ 300h;Adresse Port A
	PortB           equ 301h;Adresse Port B
	CntlReg         equ 303h;Adresse Kontrollregister
	LslReset        equ 9Bh

;ͻ
; Variablendeklaration mit Anfangswert                                     
;ͼ
		DATASEG

EXTRN _wartezeit : dword

;ͻ
; Variablendeklaration ohne Anfangswert                                    
;ͼ
		UDATASEG

;ͻ
; Programmdeklaration                                                      
;ͼ
		CODESEG

PUBLIC _Lauflicht

;͸
; Unterprogramme                                                           
;;
;Ŀ
; I/O-Baustein 8255 initialisieren                                         
;
InitPorts proc           ;8255-Baustein initialisieren
	push    ax      ;alle im Unterprogramm benutzte Register sichern
	push    dx
	mov     al, 8Bh
	mov     dx, CntlReg
	out     dx, al
	pop     dx      ;Register restaurieren
	pop     ax
	ret             ;Ruecksprung
InitPorts endp          ;Unterprogramm Ende


;Ŀ
; Port A,B und C zuruecksetzen (alle auf Eingang)                          
;
ResetPorts proc         ;8255-Baustein zuruecksetzen
	push    ax      ;alle im Unterprogramm benutzte Register sichern
	push    dx
	mov     al, LslReset
	mov     dx, CntlReg
	out     dx, al
	pop     dx      ;Register restaurieren
	pop     ax
	ret             ;Ruecksprung
ResetPorts endp         ;Unterprogramm Ende


;Ŀ
; Port B einlesen                                                          
;
ReadPortB proc          ;Liest Port B und uebergibt ihn ueber Stack an main
	push    bp
	mov     bp, sp
	push    ax      ;alle im Unterprogramm benutzte Register sichern
	push    dx
	mov     dx, PortB
	in      al, dx
	mov     [bp + 4], al
	pop     dx      ;Register restaurieren
	pop     ax
	pop     bp
	ret             ;Ruecksprung
ReadPortB endp          ;Unterprogramm Ende


;Ŀ
; Port A ausgeben                                                          
;
WritePortA proc         ;Uebergebene Parameter auf Port A ausgeben
	push    bp
	mov     bp, sp
	push    ax
	push    dx
	mov     dx, PortA
	mov     al, [bp + 4]
	out     dx, al
	pop     dx
	pop     ax
	pop     bp
	ret     2       ;Ruecksprung
WritePortA endp         ;Unterprogramm Ende

; bergabe Wert in AX
ausgabe proc
	push ax
	push dx
	push cx
	push bx

	mov bx,10
	mov cx,0

	; DX:AX / BX -> DX: bertrag, AX: Ganzzahlanteil

ausgloop:
	mov dx,0

	div bx
	add dx, '0'
	push dx

	inc cx

	cmp ax,0
	jnz ausgloop

	mov ah,2

gibaus: pop dx
	int 21h
	loop gibaus

	mov dl,13
	int 21h
	mov dl,10
	int 21h

	pop bx
	pop cx
	pop dx
	pop ax
	ret
ausgabe endp


;͸
; Hauptprogramm                                                            
;;
; Main:
_Lauflicht proc
   push   si
   push   di

	call    InitPorts
	mov     bx, 0000h
	mov     dx, 0000h
	mov     di, 0000h
	mov     cx, 10
	mov     si, 0

;*************************************************************
;* Hauptschleife

Loop1:
	push    bx
	call    ReadPortB
	pop     bx
	cmp     bx, di
	jz      Weiter1
	mov     dx, bx
	mov     di, dx
	jmp     Weiter2

Weiter1:
	ror     dl, 1

Weiter2:
	push    dx
	call    WritePortA

;*************************************************************
;* Warteschleife

	push    ecx
	mov 	ecx,0
	mov     ecx, _wartezeit
Loop2:
	loopd   Loop2
	pop     ecx

;**************************************************************
;* Ausgabezhler (CX Schleifenlufe, SI Zhler)

	loop    drueber
	mov     cx,10
	push    ax
	inc     si
	mov     ax, si
	;call    ausgabe
	pop     ax
drueber:

;**************************************************************
;* Wenn alle Schalter an sind, abbruch

	cmp     dl, 0FFh
	jnz     Loop1

	call    ResetPorts      ;Zuruecksetzen des 8255
   pop          di
   pop          si
   ret
_Lauflicht endp
				end
